! Temporiser.h
! ----------------------------------------
! Cette toute mini-extension ajoute une fonction qui permet de faire une pause
! pendant un nombre de secondes donn dans un jeu, qu'il soit Z-code ou Glulx.
! Il ne s'agit pas d'une extension neuve : en ralit la fonction utilise est
! la fonction EsperarTecla dans l'extension BajoNivel.h, extension qui elle est
! (c) 2000 Zak McKracken (17/Octubre/2000)
!
! La fonction marche de la manire suivante :
!             - si vous ne mettez rien en argument, le jeu attend simplement
!              que le joueur appuie sur une touche.
!             - si vous mettez un premier argument, il s'agira du texte affich
!              par le jeu en attendant que le joueur appuie sur une touche.
!             - si vous mettez un second argument, il s'agira du nombre maximum
!              de diximes de secondes que le jeu attendra.
!
! Exemple :
!          temp("[Appuyez sur une touche]", 100);
! Le jeu affichera [Appuyez sur une touche] et attendra dix secondes maximum
! que le joueur appuie sur une touche. Si le joueur appuie sur une touche avant,
! le jeu continuera sans attendre la fin des dix secondes.
!
! Si vous voulez attendre un certain temps, mais sans rien afficher, vous pouvez
! crire :
!          temp(0,100);
!
! Attention : certains interprteurs ne permettent pas de faire une pause
! pour un certain temps ; ils se comporteront alors en attendant simplement que
! le joueur appuie sur une touche (ils attendront pendant un temps infini, sans
! prendre en compte le deuxime argument).

System_file;

#ifndef WORDSIZE;
Constant WORDSIZE = 2;
Constant TARGET_ZCODE;
#endif;

#ifdef TARGET_ZCODE;

[ Retour;
    rtrue;
];

[ Temp msg delay k;
    if (msg~=0) print (string) msg;
    if (delay==0)
        @read_char 1 0 0 k;
    else @read_char 1 delay Retour k;
    return k;
];

#endif;

!Je ne suis pas du tout spcialiste du Glulx, mais une fonction quivalente existe apparemment -  vous de voir comment l'adapter... :
!
!#ifdef TARGET_GLULX;
!
![ EsperarTecla s delay;
!    if (s) print (string) s;
!    glk($00D6, delay*100); ! request_timer_events
!    glk($00D2, gg_mainwin); ! glk_request_char_event(gg_mainwin);
!    while(1) 
!    {
!    glk($00C0, gg_arguments); ! glk_select(gg_arguments);
!    if ((gg_arguments-->0) == 2) break; ! 2=evType_CharInput
!    if ((gg_arguments-->0) == 1)
!    {
!        glk($00D3, gg_mainwin); ! cancel_char_event
!            glk($00D6, 0); ! request_timer_events (cancelados)
!        return 0;
!    }
!    }
!    return gg_arguments-->2;
!];
!
!#endif;
